const myhero = require('myhero');
const logger = require('myhero-logger').getLogger('myhero-exception', 'uncaughtException');

/**
 * Init app for client.
 */
const app = myhero.createApp();
app.set('name', '$');

app.configure('all', function () {
    // 配置消息发送策略
    app.set('pushSchedulerConfig',
        {
            scheduler: myhero.pushSchedulers.buffer
        });
});

// app configuration
app.configure('all', 'connector', function () {
    // 加载keys
    let aes = require('./config/keys').aes;

    // 配置connector
    app.set('connectorConfig',
        {
            connector: myhero.connectors.hybridconnector,
            heartbeat: 3,       //心跳间隔，秒
            useDict: true,      //路由压缩
            useProtobuf: true,  //消息压缩
            useCrypto: true,    //消息验签

            aesKey: aes.key,    //handshake AES加密key
            cbciv: aes.iv,      //handshake AES加密iv

            checkClient: function (type, version, sha) {
                // 检测客户端版本
                logger.info('checkClient type=%, version=%s, sha=%s', type, version, sha);
                return true;
            }
        });
});

// start app
app.start();

process.on('uncaughtException', function (err) {
    logger.error(err.msg + '\n' + err.stack);
});
